import {
	inject,
	observer,
} from 'mobx-react'
import {
	toJS
} from 'mobx'
import {
	WeaTableNew
} from 'comsMobx'
import {
	Modal,
	message
} from 'antd'
import {
	i18n
} from '../../public/i18n';
const WeaTable = WeaTableNew.WeaTable;
const confirm = Modal.confirm;

@inject('hrmFuncManageDecent')
@observer
export default class MainTable extends React.Component {
	constructor(props) {
		super(props);
	}

	componentDidMount() {
		this.props.hrmFuncManageDecent.getTableInfo();
	}

	showConfirm = () => {
		let _this = this;
		confirm({
			title: i18n.confirm.defaultTitle(),
			content: i18n.confirm.delete(),
			okText: i18n.button.ok(),
			cancelText: i18n.button.cancel(),
			onOk() {
				_this.onOk()
			},
			onCancel() {
				_this.props.hrmFuncManageDecent.resetSelectedRowKeys();
				return false
			},
		});
	}

	onOk = () => {
		this.props.hrmFuncManageDecent.deleteTableInfo();
	}

	onOperatesClick = (record, rowIndex, operate) => {
		const {
			hrmFuncManageDecent
		} = this.props, {
			setSelectedRowKeys,
			openDialog,
		} = hrmFuncManageDecent, {
			randomFieldId
		} = record, {
			index
		} = operate;

		if (index == '0' || index == '1') setSelectedRowKeys(randomFieldId);

		switch (index) {
			case '0':
				openDialog();
				break;
			case '1':
				this.showConfirm();
				break;
			case '2':
				message.info(i18n.message.implementation());
				break;
		}

	}

	render() {
		const {
			hrmFuncManageDecent,
		} = this.props, {
			mainTable,
		} = hrmFuncManageDecent, {
			tableStore
		} = mainTable;

		return (
			<WeaTable ecId={`${this && this.props && this.props.ecId || ''}_WeaTable@1blt6n`} 
			 	comsWeaTableStore={tableStore}
			 	hasOrder={true}
			 	needScroll={true}
			 	onOperatesClick={(record, rowIndex, operate) => this.onOperatesClick(record, rowIndex, operate)}
			/>
		)

	}
}